home *** CD-ROM | disk | FTP | other *** search
/ Personal Computer World 2009 February / PCWFEB09.iso / Software / Linux / Kubuntu 8.10 / kubuntu-8.10-desktop-i386.iso / casper / filesystem.squashfs / usr / bin / ldd < prev    next >
Text File  |  2008-09-29  |  6KB  |  214 lines

  1. #! /bin/bash
  2. # Copyright (C) 1996-2007, 2008 Free Software Foundation, Inc.
  3. # This file is part of the GNU C Library.
  4.  
  5. # The GNU C Library is free software; you can redistribute it and/or
  6. # modify it under the terms of the GNU Lesser General Public
  7. # License as published by the Free Software Foundation; either
  8. # version 2.1 of the License, or (at your option) any later version.
  9.  
  10. # The GNU C Library is distributed in the hope that it will be useful,
  11. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  12. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  13. # Lesser General Public License for more details.
  14.  
  15. # You should have received a copy of the GNU Lesser General Public
  16. # License along with the GNU C Library; if not, write to the Free
  17. # Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
  18. # 02111-1307 USA.
  19.  
  20.  
  21. # This is the `ldd' command, which lists what shared libraries are
  22. # used by given dynamically-linked executables.  It works by invoking the
  23. # run-time dynamic linker as a command and setting the environment
  24. # variable LD_TRACE_LOADED_OBJECTS to a non-empty value.
  25.  
  26. # We should be able to find the translation right at the beginning.
  27. TEXTDOMAIN=libc
  28. TEXTDOMAINDIR=/usr/share/locale
  29.  
  30. RTLDLIST="/lib/ld-linux.so.2 /lib64/ld-linux-x86-64.so.2"
  31. warn=
  32. bind_now=
  33. verbose=
  34. filename_magic_regex="((^|/)lib|.so$)"
  35.  
  36. while test $# -gt 0; do
  37.   case "$1" in
  38.   --vers | --versi | --versio | --version)
  39.     echo 'ldd (GNU libc) 2.8.90'
  40.     printf $"Copyright (C) %s Free Software Foundation, Inc.
  41. This is free software; see the source for copying conditions.  There is NO
  42. warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  43. " "2008"
  44.     printf $"Written by %s and %s.
  45. " "Roland McGrath" "Ulrich Drepper"
  46.     exit 0
  47.     ;;
  48.   --h | --he | --hel | --help)
  49.     echo $"Usage: ldd [OPTION]... FILE...
  50.       --help              print this help and exit
  51.       --version           print version information and exit
  52.   -d, --data-relocs       process data relocations
  53.   -r, --function-relocs   process data and function relocations
  54.   -u, --unused            print unused direct dependencies
  55.   -v, --verbose           print all information
  56. For bug reporting instructions, please see:
  57. <http://www.gnu.org/software/libc/bugs.html>."
  58.     exit 0
  59.     ;;
  60.   -d | --d | --da | --dat | --data | --data- | --data-r | --data-re | \
  61.   --data-rel | --data-relo | --data-reloc | --data-relocs)
  62.     warn=yes
  63.     shift
  64.     ;;
  65.   -r | --f | --fu | --fun | --func | --funct | --functi | --functio | \
  66.   --function | --function- | --function-r | --function-re | --function-rel | \
  67.   --function-relo | --function-reloc | --function-relocs)
  68.     warn=yes
  69.     bind_now=yes
  70.     shift
  71.     ;;
  72.   -v | --verb | --verbo | --verbos | --verbose)
  73.     verbose=yes
  74.     shift
  75.     ;;
  76.   -u | --u | --un | --unu | --unus | --unuse | --unused)
  77.     unused=yes
  78.     shift
  79.     ;;
  80.   --v | --ve | --ver)
  81.     echo >&2 $"ldd: option \`$1' is ambiguous"
  82.     exit 1
  83.     ;;
  84.   --)        # Stop option processing.
  85.     shift; break
  86.     ;;
  87.   -*)
  88.     echo >&2 'ldd:' $"unrecognized option" "\`$1'"
  89.     echo >&2 $"Try \`ldd --help' for more information."
  90.     exit 1
  91.     ;;
  92.   *)
  93.     break
  94.     ;;
  95.   esac
  96. done
  97.  
  98. nonelf ()
  99. {
  100.   # Maybe extra code for non-ELF binaries.
  101.   return 1;
  102. }
  103.  
  104. add_env="LD_TRACE_LOADED_OBJECTS=1 LD_WARN=$warn LD_BIND_NOW=$bind_now"
  105. add_env="$add_env LD_LIBRARY_VERSION=\$verify_out"
  106. add_env="$add_env LD_VERBOSE=$verbose"
  107. if test "$unused" = yes; then
  108.   add_env="$add_env LD_DEBUG=\"$LD_DEBUG${LD_DEBUG:+,}unused\""
  109. fi
  110.  
  111. # The following use of cat is needed to make ldd work in SELinux
  112. # environments where the executed program might not have permissions
  113. # to write to the console/tty.  But only bash 3.x supports the pipefail
  114. # option, and we don't bother to handle the case for older bash versions.
  115. if set -o pipefail 2> /dev/null; then
  116.   try_trace() {
  117.     eval $add_env '"$@"' | cat
  118.   }
  119. else
  120.   try_trace() {
  121.     eval $add_env '"$@"'
  122.   }
  123. fi
  124.  
  125. case $# in
  126. 0)
  127.   echo >&2 'ldd:' $"missing file arguments"
  128.   echo >&2 $"Try \`ldd --help' for more information."
  129.   exit 1
  130.   ;;
  131. 1)
  132.   single_file=t
  133.   ;;
  134. *)
  135.   single_file=f
  136.   ;;
  137. esac
  138.  
  139. result=0
  140. for file do
  141.   # We don't list the file name when there is only one.
  142.   test $single_file = t || echo "${file}:"
  143.   case $file in
  144.   */*) :
  145.        ;;
  146.   *) file=./$file
  147.      ;;
  148.   esac
  149.   if test ! -e "$file"; then
  150.     echo "ldd: ${file}:" $"No such file or directory" >&2
  151.     result=1
  152.   elif test ! -f "$file"; then
  153.     echo "ldd: ${file}:" $"not regular file" >&2
  154.     result=1
  155.   elif test -r "$file"; then
  156.     if test ! -x "$file" && eval echo "$file" \
  157.     | egrep -v "$filename_magic_regex" > /dev/null; then
  158.     echo 'ldd:' $"warning: you do not have execution permission for"\
  159.         "\`$file'" >&2
  160.     fi
  161.     RTLD=
  162.     ret=1
  163.     for rtld in ${RTLDLIST}; do
  164.       if test -x $rtld; then
  165.     verify_out=`${rtld} --verify "$file" 2>/dev/null`
  166.         ret=$?
  167.     case $ret in
  168.     [02]) RTLD=${rtld}; break;;
  169.     esac
  170.       fi
  171.     done
  172.     case $ret in
  173.     0)
  174.       # If the program exits with exit code 5, it means the process has been
  175.       # invoked with __libc_enable_secure.  Fall back to running it through
  176.       # the dynamic linker.
  177.       if test -x "$file"; then
  178.     try_trace "$file"
  179.       else
  180.     try_trace "${RTLD}" "$file"
  181.       fi
  182.       rc=$?
  183.       if [ $rc = 5 ]; then
  184.     try_trace "$RTLD" "$file"
  185.     rc=$?
  186.       fi
  187.       [ $rc = 0 ] || result=1
  188.       ;;
  189.     1)
  190.       # This can be a non-ELF binary or no binary at all.
  191.       nonelf "$file" || {
  192.     echo $"    not a dynamic executable"
  193.     result=1
  194.       }
  195.       ;;
  196.     2)
  197.       try_trace "$RTLD" "$file" || result=1
  198.       ;;
  199.     *)
  200.       echo 'ldd:' ${RTLD} $"exited with unknown exit code" "($ret)" >&2
  201.       exit 1
  202.       ;;
  203.     esac
  204.   else
  205.     echo 'ldd:' $"error: you do not have read permission for" "\`$file'" >&2
  206.     result=1
  207.   fi
  208. done
  209.  
  210. exit $result
  211. # Local Variables:
  212. #  mode:ksh
  213. # End:
  214.